"""Czysty kod w Pythonie - Rozdział 09: Typowe wzorce projektowe

> Wzorzec Monostat
"""
from log import logger


class GitFetcher:
    _current_tag = None

    def __init__(self, tag):
        self.current_tag = tag

    @property
    def current_tag(self):
        if self._current_tag is None:
            raise AttributeError("tag nigdy nie został ustawiony")
        return self._current_tag

    @current_tag.setter
    def current_tag(self, new_tag):
        self.__class__._current_tag = new_tag

    def pull(self):
        logger.info("pobieranie z %s", self.current_tag)
        return self.current_tag
